#include "UITerminal.h"
#include "UINode.h"
#include "UILink.h"
#include "UINetTerminal.h"



UITerminal::UITerminal (string _name, UINode *_node, bool _isInput, double _x, double _y)
   : name(_name)
   , node(_node)
   , x(_x)
   , y(_y)
   , isInput(_isInput)
   , netTerminal(NULL)
{

}

UITerminal::~UITerminal() 
{
/*   for (int i=0;i<connections.size();i++)
      delete connections[i];
*/
   //although this is wierd, it has to be like that since the destroyed link removes 
   //itself from the connection list
   while (connections.size())
      delete connections[0];

   if (netTerminal)
      delete netTerminal;
}



void UITerminal::export2net (ostream &out)
{
   if (!isInput) 
      return;
   if (connections.size() != 1 && !netTerminal)
   {
      cerr << "input error!\n";
      return;
   }

   if (netTerminal)
   {
      out << "   <input: " << name << ", ALL_NETWORK_INPUTS, " 
          << netTerminal->getName() << ">" << endl;
   } else {
      out << "   <input: " << name << ", " << connections[0]->from->node->getName() 
          << ", " << connections[0]->from->name << ">" << endl;
   }
   //connections[0]
}
